diff --git a/mysql-test/suite/compat/oracle/t/sp-expr.result b/mysql-test/suite/compat/oracle/t/sp-expr.result
new file mode 100644
index 0000000..38a3d4c
--- /dev/null
+++ b/mysql-test/suite/compat/oracle/t/sp-expr.result
@@ -0,0 +1,389 @@
+#
+# Start of 10.4 tests
+#
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1);
+BEGIN NOT ATOMIC
+CASE ((1) IN (SELECT a FROM t1)) WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+1
+1
+BEGIN NOT ATOMIC
+CASE (EXISTS (SELECT a FROM t1)) WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+1
+1
+BEGIN NOT ATOMIC
+IF ((1) IN (SELECT a FROM t1)) THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+1
+1
+BEGIN NOT ATOMIC
+IF (EXISTS (SELECT a FROM t1)) THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+1
+1
+BEGIN NOT ATOMIC
+WHILE ((1234) IN (SELECT * FROM t1)) DO
+SELECT 1;
+END WHILE;
+END;
+$$
+BEGIN NOT ATOMIC
+WHILE (EXISTS (SELECT * FROM t1 WHERE a=1234)) DO
+SELECT 1;
+END WHILE;
+END;
+$$
+BEGIN NOT ATOMIC
+REPEAT
+SELECT 1;
+UNTIL (1 IN (SELECT * FROM t1))
+END REPEAT;
+END;
+$$
+1
+1
+BEGIN NOT ATOMIC
+REPEAT
+SELECT 1;
+UNTIL EXISTS (SELECT * FROM t1 WHERE a=1)
+END REPEAT;
+END;
+$$
+1
+1
+BEGIN NOT ATOMIC
+FOR i IN 0..(1 IN (SELECT * FROM t1))
+DO
+SELECT i;
+END FOR;
+END;
+$$
+i
+0
+i
+1
+BEGIN NOT ATOMIC
+FOR i IN 0..EXISTS (SELECT * FROM t1 WHERE a=1)
+DO
+SELECT i;
+END FOR;
+END;
+$$
+i
+0
+i
+1
+DROP TABLE t1;
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (10);
+BEGIN NOT ATOMIC
+DECLARE a INT DEFAULT ((10) IN (SELECT * FROM t1));
+SELECT a;
+END;
+$$
+a
+1
+BEGIN NOT ATOMIC
+DECLARE a INT DEFAULT EXISTS (SELECT * FROM t1);
+SELECT a;
+END;
+$$
+a
+1
+DROP TABLE t1;
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1);
+CREATE FUNCTION f1() RETURNS INT
+BEGIN
+RETURN ((1) IN (SELECT * FROM t1));
+END;
+$$
+CREATE FUNCTION f2() RETURNS INT
+BEGIN
+RETURN EXISTS (SELECT * FROM t1 WHERE a=1);
+END;
+$$
+SELECT f1();
+f1()
+1
+SELECT f2();
+f2()
+1
+DROP FUNCTION f1;
+DROP FUNCTION f2;
+DROP TABLE t1;
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+BEGIN NOT ATOMIC
+DECLARE va INT;
+DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+OPEN cur(1 IN (SELECT * FROM t1));
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+va
+2
+BEGIN NOT ATOMIC
+DECLARE va INT;
+DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+OPEN cur(EXISTS (SELECT * FROM t1));
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+va
+2
+DROP TABLE t1;
+#
+# MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+#
+BEGIN NOT ATOMIC
+CASE unknown_identifier WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+BEGIN NOT ATOMIC
+CASE unknown_identifier.a WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+BEGIN NOT ATOMIC
+CASE unknown_identifier.a.b WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+CASE unknown_identifier.a.b.c WHEN 1 THEN SELECT 1;
+ELSE SELECT NULL;
+END CASE;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+IF unknown_identifier THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+BEGIN NOT ATOMIC
+IF unknown_identifier.a THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+BEGIN NOT ATOMIC
+IF unknown_identifier.a.b THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+IF unknown_identifier.a.b.c THEN SELECT 1;
+ELSE SELECT NULL;
+END IF;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+WHILE unknown_identifier DO
+SELECT 1;
+END WHILE;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+BEGIN NOT ATOMIC
+WHILE unknown_identifier.a DO
+SELECT 1;
+END WHILE;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+BEGIN NOT ATOMIC
+WHILE unknown_identifier.a.b DO
+SELECT 1;
+END WHILE;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+WHILE unknown_identifier.a.b.c DO
+SELECT 1;
+END WHILE;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+REPEAT
+SELECT 1;
+UNTIL unknown_identifier;
+END REPEAT;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+BEGIN NOT ATOMIC
+REPEAT
+SELECT 1;
+UNTIL unknown_identifier.a;
+END REPEAT;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+BEGIN NOT ATOMIC
+REPEAT
+SELECT 1;
+UNTIL unknown_identifier.a.b;
+END REPEAT;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+REPEAT
+SELECT 1;
+UNTIL unknown_identifier.a.b.c;
+END REPEAT;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+BEGIN NOT ATOMIC
+FOR i IN 0..unknown_identifier
+DO
+SELECT i;
+END FOR;
+END;
+$$
+ERROR 42000: Undeclared variable: unknown_identifier
+BEGIN NOT ATOMIC
+FOR i IN 0..unknown_identifier.field1
+DO
+SELECT i;
+END FOR;
+END;
+$$
+ERROR 42000: Undeclared variable: unknown_identifier.field1
+BEGIN NOT ATOMIC
+FOR i IN 0..unknown_identifier.field1.field2
+DO
+SELECT i;
+END FOR;
+END;
+$$
+ERROR 42000: Undeclared variable: field1.field2
+BEGIN NOT ATOMIC
+FOR i IN unknown_identifier..10
+DO
+SELECT i;
+END FOR;
+END;
+$$
+ERROR 42000: Undeclared variable: unknown_identifier
+BEGIN NOT ATOMIC
+FOR i IN unknown_identifier.field1..10
+DO
+SELECT i;
+END FOR;
+END;
+$$
+ERROR 42000: Undeclared variable: unknown_identifier.field1
+BEGIN NOT ATOMIC
+FOR i IN unknown_identifier.field1.field2..10
+DO
+SELECT i;
+END FOR;
+END;
+$$
+ERROR 42000: Undeclared variable: field1.field2
+BEGIN NOT ATOMIC
+DECLARE a INT DEFAULT unknown_identifier;
+SELECT a;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+BEGIN NOT ATOMIC
+DECLARE a INT DEFAULT unknown_identifier.a;
+SELECT a;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'field list'
+BEGIN NOT ATOMIC
+DECLARE a INT DEFAULT unknown_identifier.a.b;
+SELECT a;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE FUNCTION f1() RETURNS INT RETURN unknown_identifier;
+ERROR 42S22: Unknown column 'unknown_identifier' in 'field list'
+CREATE FUNCTION f1() RETURNS INT RETURN unknown_identifier.a;
+ERROR 42S22: Unknown column 'a' in 'field list'
+CREATE FUNCTION f1() RETURNS INT RETURN unknown_identifier.a.b;
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE FUNCTION f1() RETURNS INT RETURN unknown_identifier.a.b.c;
+ERROR 42S22: Unknown column 'b' in 'field list'
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+BEGIN NOT ATOMIC
+DECLARE va INT;
+DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+OPEN cur(unknown_identifier);
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+ERROR 42S22: Unknown column 'unknown_identifier' in 'ORDER clause'
+BEGIN NOT ATOMIC
+DECLARE va INT;
+DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+OPEN cur(unknown_identifier.a);
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+ERROR 42S22: Unknown column 'a' in 'ORDER clause'
+BEGIN NOT ATOMIC
+DECLARE va INT;
+DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+OPEN cur(unknown_identifier.a.b);
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'ORDER clause'
+BEGIN NOT ATOMIC
+DECLARE va INT;
+DECLARE cur CURSOR(amin INT) FOR SELECT a FROM t1 WHERE a>amin ORDER BY a;
+OPEN cur(unknown_identifier.a.b.c);
+FETCH cur INTO va;
+SELECT va;
+CLOSE cur;
+END;
+$$
+ERROR 42S22: Unknown column 'b' in 'ORDER clause'
+DROP TABLE t1;
diff --git a/mysql-test/suite/compat/oracle/t/sp-expr.test b/mysql-test/suite/compat/oracle/t/sp-expr.test
new file mode 100644
index 0000000..2e589f7
--- /dev/null
+++ b/mysql-test/suite/compat/oracle/t/sp-expr.test
@@ -0,0 +1,820 @@
+# Testing expressions of different kinds in various parts of SP syntax
+
+SET sql_mode=ORACLE;
+
+--echo #
+--echo # Start of 10.4 tests
+--echo #
+
+#
+# Subselects in SP control structures
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1);
+DELIMITER $$;
+
+BEGIN
+  CASE ((1) IN (SELECT a FROM t1)) WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+BEGIN
+  CASE (EXISTS (SELECT a FROM t1)) WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+BEGIN
+  IF ((1) IN (SELECT a FROM t1)) THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+BEGIN
+  IF (EXISTS (SELECT a FROM t1)) THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+BEGIN
+  WHILE ((1234) IN (SELECT * FROM t1)) LOOP
+    SELECT 1;
+  END LOOP;
+END;
+$$
+BEGIN
+  WHILE (EXISTS (SELECT * FROM t1 WHERE a=1234)) LOOP
+    SELECT 1;
+  END LOOP;
+END;
+$$
+
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL (1 IN (SELECT * FROM t1))
+  END REPEAT;
+END;
+$$
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL EXISTS (SELECT * FROM t1 WHERE a=1)
+  END REPEAT;
+END;
+$$
+
+BEGIN
+  FOR i IN 0..(1 IN (SELECT * FROM t1))
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+BEGIN
+  FOR i IN 0..EXISTS (SELECT * FROM t1 WHERE a=1)
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+DELIMITER ;$$
+DROP TABLE t1;
+
+
+#
+# Subselects as SP variable default values
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (10);
+DELIMITER $$;
+DECLARE
+  a INT DEFAULT ((10) IN (SELECT * FROM t1));
+BEGIN
+  SELECT a;
+END;
+$$
+DECLARE
+  a INT DEFAULT EXISTS (SELECT * FROM t1);
+BEGIN
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+DROP TABLE t1;
+
+
+#
+# Subselects SP function return values
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1);
+DELIMITER $$;
+CREATE FUNCTION f1() RETURN INT AS
+BEGIN
+  RETURN ((1) IN (SELECT * FROM t1));
+END;
+$$
+CREATE FUNCTION f2() RETURN INT AS
+BEGIN
+  RETURN EXISTS (SELECT * FROM t1 WHERE a=1);
+END;
+$$
+DELIMITER ;$$
+SELECT f1();
+SELECT f2();
+DROP FUNCTION f1;
+DROP FUNCTION f2;
+DROP TABLE t1;
+
+
+#
+# Subselects in CURSOR parameters
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DELIMITER $$;
+DECLARE
+  va INT;
+  CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+  OPEN cur(1 IN (SELECT * FROM t1));
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+DECLARE
+  va INT;
+  CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+  OPEN cur(EXISTS (SELECT * FROM t1));
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+DELIMITER ;$$
+DROP TABLE t1;
+
+
+--echo #
+--echo # MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+--echo #
+
+#
+# Unknown identifiers in CASE SP control
+#
+
+DELIMITER $$;
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  CASE unknown_identifier WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  CASE unknown_identifier.a WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  CASE unknown_identifier.a.b WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  CASE unknown_identifier.a.b.c WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+
+#
+# Unknown identifiers in IF
+#
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  IF unknown_identifier THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  IF unknown_identifier.a THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  IF unknown_identifier.a.b THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  IF unknown_identifier.a.b.c THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+
+#
+# Unknown identifiers in WHILE
+#
+
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  WHILE unknown_identifier LOOP
+    SELECT 1;
+  END LOOP;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  WHILE unknown_identifier.a LOOP
+    SELECT 1;
+  END LOOP;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  WHILE unknown_identifier.a.b LOOP
+    SELECT 1;
+  END LOOP;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  WHILE unknown_identifier.a.b.c LOOP
+    SELECT 1;
+  END LOOP;
+END;
+$$
+
+
+
+#
+# Unknown identifiers in REPEAT
+#
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL unknown_identifier;
+  END REPEAT;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL unknown_identifier.a;
+  END REPEAT;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL unknown_identifier.a.b;
+  END REPEAT;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL unknown_identifier.a.b.c;
+  END REPEAT;
+END;
+$$
+
+
+#
+# Unknown identifiers in FOR
+#
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1() AS
+BEGIN
+  FOR i IN 0..unknown_identifier
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1() AS
+BEGIN
+  FOR i IN 0..unknown_identifier.field1
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1() AS
+BEGIN
+  FOR i IN 0..unknown_identifier.field1.field2
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1() AS
+BEGIN
+  FOR i IN unknown_identifier..10
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1() AS
+BEGIN
+  FOR i IN unknown_identifier.field1..10
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+
+--error ER_SP_UNDECLARED_VAR
+CREATE PROCEDURE p1() AS
+BEGIN
+  FOR i IN unknown_identifier.field1.field2..10
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+
+DELIMITER ;$$
+
+
+#
+# Unknown identifiers as SP variable default values
+#
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+  a INT DEFAULT unknown_identifier;
+BEGIN
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+  a INT DEFAULT unknown_identifier.a;
+BEGIN
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+  a INT DEFAULT unknown_identifier.a.b;
+BEGIN
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+
+
+#
+# Unknown identifiers as SP function return values
+#
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN unknown_identifier; END;
+$$
+DELIMITER ;$$
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN unknown_identifier.a; END;
+$$
+DELIMITER ;$$
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN unknown_identifier.a.b; END;
+$$
+DELIMITER ;$$
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN unknown_identifier.a.b.c; END;
+$$
+DELIMITER ;$$
+
+
+#
+# Unknown identifiers in CURSOR parameters
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DELIMITER $$;
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+  va INT;
+  CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+  OPEN cur(unknown_identifier);
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+  va INT;
+  CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+  OPEN cur(unknown_identifier.a);
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+  va INT;
+  CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+  OPEN cur(unknown_identifier.a.b);
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+  va INT;
+  CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+  OPEN cur(unknown_identifier.a.b.c);
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+DELIMITER ;$$
+DROP TABLE t1;
+
+
+--echo #
+--echo # MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+--echo #
+--echo # (testing aggregate functions)
+
+#
+# Aggregate functions in CASE SP control
+#
+
+DELIMITER $$;
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1() AS
+BEGIN
+  CASE SUM(1) WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+
+#
+# Aggregate functions in IF
+#
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1() AS
+BEGIN
+  IF SUM(1) THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+
+#
+# Aggregate functions in WHILE
+#
+
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1() AS
+BEGIN
+  WHILE SUM(1) LOOP
+    SELECT 1;
+  END LOOP;
+END;
+$$
+
+
+
+#
+# Aggregate functions in REPEAT
+#
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1() AS
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL SUM(1);
+  END REPEAT;
+END;
+$$
+
+#
+# Aggregate functions in FOR
+#
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1() AS
+BEGIN
+  FOR i IN 0..SUM(1)
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1() AS
+BEGIN
+  FOR i IN SUM(1)..10
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+
+DELIMITER ;$$
+
+
+#
+# Aggregate functions as SP variable default values
+#
+
+DELIMITER $$;
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1() AS
+  a INT DEFAULT SUM(1);
+BEGIN
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+
+
+#
+# Aggregate functions as SP function return values
+#
+
+DELIMITER $$;
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN SUM(1); END;
+$$
+DELIMITER ;$$
+
+
+#
+# Aggregate functions in CURSOR parameters
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DELIMITER $$;
+
+--error ER_INVALID_GROUP_FUNC_USE
+CREATE PROCEDURE p1() AS
+  va INT;
+  CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+  OPEN cur(SUM(1));
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+DELIMITER ;$$
+DROP TABLE t1;
+
+
+--echo #
+--echo # MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+--echo #
+--echo # (testing window functions)
+
+#
+# Window functions in CASE SP control
+#
+
+DELIMITER $$;
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1() AS
+BEGIN
+  CASE ROW_NUMBER() OVER() WHEN 1 THEN SELECT 1;
+  ELSE SELECT NULL;
+  END CASE;
+END;
+$$
+
+
+#
+# Window functions in IF
+#
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1() AS
+BEGIN
+  IF ROW_NUMBER() OVER() THEN SELECT 1;
+  ELSE SELECT NULL;
+  END IF;
+END;
+$$
+
+
+#
+# Window functions in WHILE
+#
+
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1() AS
+BEGIN
+  WHILE ROW_NUMBER() OVER() LOOP
+    SELECT 1;
+  END LOOP;
+END;
+$$
+
+
+
+#
+# Window functions in REPEAT
+#
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1() AS
+BEGIN
+  REPEAT
+    SELECT 1;
+  UNTIL ROW_NUMBER() OVER();
+  END REPEAT;
+END;
+$$
+
+#
+# Window functions in FOR
+#
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1() AS
+BEGIN
+  FOR i IN 0..ROW_NUMBER() OVER()
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1() AS
+BEGIN
+  FOR i IN ROW_NUMBER() OVER()..10
+  LOOP
+    SELECT i;
+  END LOOP;
+END;
+$$
+
+DELIMITER ;$$
+
+
+#
+# Window functions as SP variable default values
+#
+
+DELIMITER $$;
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1() AS
+  a INT DEFAULT ROW_NUMBER() OVER();
+BEGIN
+  SELECT a;
+END;
+$$
+DELIMITER ;$$
+
+
+#
+# Window functions as SP function return values
+#
+
+DELIMITER $$;
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE FUNCTION f1() RETURN INT AS BEGIN RETURN ROW_NUMBER() OVER(); END;
+$$
+DELIMITER ;$$
+
+
+#
+# Window functions in CURSOR parameters
+#
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DELIMITER $$;
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CREATE PROCEDURE p1() AS
+  va INT;
+  CURSOR cur(amin INT) IS SELECT a FROM t1 WHERE a>amin ORDER BY a;
+BEGIN
+  OPEN cur(ROW_NUMBER() OVER());
+  FETCH cur INTO va;
+  SELECT va;
+  CLOSE cur;
+END;
+$$
+
+DELIMITER ;$$
+DROP TABLE t1;
diff --git a/mysql-test/suite/compat/oracle/t/sp.test b/mysql-test/suite/compat/oracle/t/sp.test
index b88271a..de2a4a5 100644
--- a/mysql-test/suite/compat/oracle/t/sp.test
+++ b/mysql-test/suite/compat/oracle/t/sp.test
@@ -1092,6 +1092,7 @@ DROP FUNCTION f1;
 --echo #
 
 DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
 CREATE PROCEDURE p1
 AS
 BEGIN
@@ -1100,12 +1101,10 @@ BEGIN
   END LOOP;
 END$$
 DELIMITER ;$$
---error ER_BAD_FIELD_ERROR
-CALL p1;
-DROP PROCEDURE p1;
 
 
 DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
 CREATE PROCEDURE p1
 AS
 BEGIN
@@ -1115,12 +1114,10 @@ BEGIN
   END LOOP;
 END$$
 DELIMITER ;$$
---error ER_BAD_FIELD_ERROR
-CALL p1;
-DROP PROCEDURE p1;
 
 
 DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
 CREATE PROCEDURE p1
 AS
 BEGIN
@@ -1129,12 +1126,10 @@ BEGIN
   END LOOP;
 END$$
 DELIMITER ;$$
---error ER_BAD_FIELD_ERROR
-CALL p1;
-DROP PROCEDURE p1;
 
 
 DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
 CREATE PROCEDURE p1
 AS
 BEGIN
@@ -1144,9 +1139,6 @@ BEGIN
   END LOOP;
 END$$
 DELIMITER ;$$
---error ER_BAD_FIELD_ERROR
-CALL p1;
-DROP PROCEDURE p1;
 
 --echo #
 --echo # MDEV-10583 sql_mode=ORACLE: SQL%ROWCOUNT
diff --git a/mysql-test/suite/compat/oracle/t/statement-expr.test b/mysql-test/suite/compat/oracle/t/statement-expr.test
new file mode 100644
index 0000000..3970caf
--- /dev/null
+++ b/mysql-test/suite/compat/oracle/t/statement-expr.test
@@ -0,0 +1,304 @@
+# Testing expressions of different kinds in various non-SELECT statements
+
+SET sql_mode=ORACLE;
+
+#
+# Subselects in non-SELECT statements
+#
+
+CREATE TABLE t1 (id INT, id1 INT);
+INSERT INTO t1 VALUES (1,7);
+INSERT INTO t1 VALUES (1,8);
+SELECT ROW(1,7) IN (SELECT id, id1 FROM t1 WHERE id1= 8);
+EXECUTE IMMEDIATE 'SELECT ROW(1, 7) IN (SELECT id, id1 FROM t1 WHERE id1= 8)';
+DROP TABLE t1;
+
+--error ER_PARSE_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING (1 IN (SELECT * FROM t1));
+--error ER_PARSE_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING (SELECT * FROM t1);
+
+
+CREATE TABLE t1 (id INT);
+INSERT INTO t1 VALUES (10);
+DELIMITER $$;
+CREATE PROCEDURE p1(a INT) AS BEGIN NULL; END;
+$$
+DELIMITER ;$$
+CALL p1((1) IN (SELECT * FROM t1));
+CALL p1(EXISTS (SELECT * FROM t1));
+DROP PROCEDURE p1;
+DROP TABLE t1;
+
+--error ER_PARSE_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=(1 IN (SELECT * FROM t1));
+--error ER_PARSE_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=EXISTS (SELECT * FROM t1);
+
+DELIMITER $$;
+--error ER_PARSE_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=(1 IN (SELECT * FROM t1));
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+--error ER_PARSE_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=EXISTS (SELECT * FROM t1);
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+DELIMITER ;$$
+
+
+--error ER_PARSE_ERROR
+PREPARE stmt FROM (1 IN (SELECT * FROM t1));
+--error ER_PARSE_ERROR
+PREPARE stmt FROM EXISTS (SELECT * FROM t1);
+
+--error ER_PARSE_ERROR
+EXECUTE IMMEDIATE (1 IN (SELECT * FROM t1));
+--error ER_PARSE_ERROR
+EXECUTE IMMEDIATE EXISTS (SELECT * FROM t1);
+
+--error ER_PARSE_ERROR
+GET DIAGNOSTICS CONDITION (1 IN (SELECT * FROM t1)) @errno=MYSQL_ERRNO;
+--error ER_PARSE_ERROR
+GET DIAGNOSTICS CONDITION EXISTS (SELECT * FROM t1) @errno=MYSQL_ERRNO;
+
+--error ER_PARSE_ERROR
+PURGE BINARY LOGS BEFORE (1 IN (SELECT * FROM t1));
+--error ER_PARSE_ERROR
+PURGE BINARY LOGS BEFORE EXISTS (SELECT * FROM t1);
+
+CREATE TABLE t1 (a INT);
+INSERT INTO t1 VALUES (1),(2),(3);
+DO 1 IN (SELECT * FROM t1);
+DO EXISTS (SELECT * FROM t1);
+DROP TABLE t1;
+
+
+--echo #
+--echo # MDEV-14347 CREATE PROCEDURE returns no error when using an unknown variable
+--echo #
+
+# TODO: wrap into CREATE
+
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a.b;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE 'SELECT ?' USING unknown_identifier.a.b.c;
+
+
+DELIMITER $$;
+CREATE PROCEDURE p1(a INT) AS BEGIN NULL; END;
+$$
+DELIMITER ;$$
+--error ER_BAD_FIELD_ERROR
+CALL p1(unknown_identifier);
+--error ER_BAD_FIELD_ERROR
+CALL p1(unknown_identifier.a);
+--error ER_BAD_FIELD_ERROR
+CALL p1(unknown_identifier.a.b);
+--error ER_BAD_FIELD_ERROR
+CALL p1(unknown_identifier.a.b.c);
+DROP PROCEDURE p1;
+
+
+--error ER_BAD_FIELD_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier;
+--error ER_BAD_FIELD_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a;
+--error ER_BAD_FIELD_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a.b;
+--error ER_BAD_FIELD_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=unknown_identifier.a.b.c;
+
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=unknown_identifier;
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+--error ER_BAD_FIELD_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a;
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+--error ER_BAD_FIELD_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a.b;
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+--error ER_BAD_FIELD_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=unknown_identifier.a.b.c;
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+DELIMITER ;$$
+
+
+--error ER_BAD_FIELD_ERROR
+PREPARE stmt FROM unknown_identifier;
+--error ER_BAD_FIELD_ERROR
+PREPARE stmt FROM unknown_identifier.a;
+--error ER_BAD_FIELD_ERROR
+PREPARE stmt FROM unknown_identifier.a.b;
+--error ER_BAD_FIELD_ERROR
+PREPARE stmt FROM unknown_identifier.a.b.c;
+
+
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE unknown_identifier;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE unknown_identifier.a;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE unknown_identifier.a.b;
+--error ER_BAD_FIELD_ERROR
+EXECUTE IMMEDIATE unknown_identifier.a.b.c;
+
+
+--error ER_BAD_FIELD_ERROR
+GET DIAGNOSTICS CONDITION unknown_identifier @errno=MYSQL_ERRNO;
+--error ER_BAD_FIELD_ERROR
+GET DIAGNOSTICS CONDITION unknown_identifier.a @errno=MYSQL_ERRNO;
+--error ER_BAD_FIELD_ERROR
+GET DIAGNOSTICS CONDITION unknown_identifier.a.b @errno=MYSQL_ERRNO;
+--error ER_BAD_FIELD_ERROR
+GET DIAGNOSTICS CONDITION unknown_identifier.a.b.c @errno=MYSQL_ERRNO;
+
+
+--error ER_BAD_FIELD_ERROR
+PURGE BINARY LOGS BEFORE unknown_identifier;
+--error ER_BAD_FIELD_ERROR
+PURGE BINARY LOGS BEFORE unknown_identifier.a;
+--error ER_BAD_FIELD_ERROR
+PURGE BINARY LOGS BEFORE unknown_identifier.a.b;
+--error ER_BAD_FIELD_ERROR
+PURGE BINARY LOGS BEFORE unknown_identifier.a.b.c;
+
+
+--echo #
+--echo # MDEV-15870 Using aggregate and window function in unexpected places can crash the server
+--echo #
+
+--echo # (aggreate functions)
+
+--error ER_INVALID_GROUP_FUNC_USE
+EXECUTE IMMEDIATE 'SELECT ?' USING SUM(1);
+
+
+DELIMITER $$;
+CREATE PROCEDURE p1(a INT) AS BEGIN NULL; END;
+$$
+DELIMITER ;$$
+--error ER_INVALID_GROUP_FUNC_USE
+CALL p1(SUM(1));
+DROP PROCEDURE p1;
+
+
+--error ER_PARSE_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=SUM(1);
+
+
+DELIMITER $$;
+--error ER_PARSE_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=SUM(1);
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+DELIMITER ;$$
+
+
+--error ER_INVALID_GROUP_FUNC_USE
+PREPARE stmt FROM SUM(1);
+
+
+--error ER_INVALID_GROUP_FUNC_USE
+EXECUTE IMMEDIATE SUM(1);
+
+
+--error ER_PARSE_ERROR
+GET DIAGNOSTICS CONDITION SUM(1) @errno=MYSQL_ERRNO;
+
+
+--error ER_INVALID_GROUP_FUNC_USE
+PURGE BINARY LOGS BEFORE SUM(1);
+
+
+
+--echo #
+--echo # MDEV-15870 Using aggregate and window function in unexpected places can crash the server
+--echo #
+
+--echo # (window functions)
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+EXECUTE IMMEDIATE 'SELECT ?' USING ROW_NUMBER() OVER ();
+
+
+DELIMITER $$;
+CREATE PROCEDURE p1(a INT) AS BEGIN NULL; END;
+$$
+DELIMITER ;$$
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+CALL p1(ROW_NUMBER() OVER ());
+DROP PROCEDURE p1;
+
+
+--error ER_PARSE_ERROR
+SIGNAL SQLSTATE '01000' SET MYSQL_ERRNO=ROW_NUMBER() OVER ();
+
+
+DELIMITER $$;
+--error ER_PARSE_ERROR
+BEGIN NOT ATOMIC
+  DECLARE CONTINUE HANDLER FOR SQLWARNING
+    RESIGNAL SET MYSQL_ERRNO=ROW_NUMBER() OVER ();
+  SIGNAL SQLSTATE '01000';
+END;
+$$
+DELIMITER ;$$
+
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+PREPARE stmt FROM ROW_NUMBER() OVER ();
+
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+EXECUTE IMMEDIATE ROW_NUMBER() OVER ();
+
+
+--error ER_PARSE_ERROR
+GET DIAGNOSTICS CONDITION ROW_NUMBER() OVER () @errno=MYSQL_ERRNO;
+
+
+--error ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION
+PURGE BINARY LOGS BEFORE ROW_NUMBER() OVER ();
+
+
+DELIMITER $$;
+--error ER_BAD_FIELD_ERROR
+CREATE PROCEDURE p1() AS
+BEGIN
+  DO unknown_identifier;
+END;
+$$
+DELIMITER ;$$
diff --git a/mysql-test/suite/funcs_1/r/storedproc.result b/mysql-test/suite/funcs_1/r/storedproc.result
index e5e009a..0fe7082 100644
--- a/mysql-test/suite/funcs_1/r/storedproc.result
+++ b/mysql-test/suite/funcs_1/r/storedproc.result
@@ -15723,6 +15723,7 @@ Testcase 4.3.7:
 DROP PROCEDURE IF EXISTS sp7;
 CREATE PROCEDURE sp7()
 BEGIN
+DECLARE count INT DEFAULT 100;
 label1: loop
 set @dummystring = 'temp value';
 if count > 10 then leave label1;
@@ -15732,7 +15733,7 @@ END label1 loop;
 END//
 ERROR 42000: You have an error in your SQL syntax; check the manual that corresponds to your MariaDB server version for the right syntax to use near 'iterate;
 END label1 loop;
-END' at line 7
+END' at line 8
 DROP PROCEDURE IF EXISTS sp7;
 CREATE PROCEDURE sp7()
 BEGIN
diff --git a/mysql-test/suite/funcs_1/t/storedproc.test b/mysql-test/suite/funcs_1/t/storedproc.test
index 98385d4..3178641 100644
--- a/mysql-test/suite/funcs_1/t/storedproc.test
+++ b/mysql-test/suite/funcs_1/t/storedproc.test
@@ -18861,6 +18861,7 @@ delimiter //;
 --error ER_PARSE_ERROR
 CREATE PROCEDURE sp7()
 BEGIN
+  DECLARE count INT DEFAULT 100;
   label1: loop
     set @dummystring = 'temp value';
     if count > 10 then leave label1;
